


#ifndef __LABEL_H__
#define __LABEL_H__

#include "IUpdateable.h"

#include <qdatetime.h>
#include <qlist.h>
#include <qstring.h>

namespace Perforce {

class Label;
typedef QList< Label > LabelList;

class Label {

public:

  static const LabelList& getLabels();

  inline const QString&   getName() const;
  inline const QString&   getDescription() const;
  inline const QString&   getOwner() const;
  inline const QDateTime& getDate() const;
  inline const QString&   getStatus() const;

private:

  Label() { }

  QString   _name;
  QDateTime _date;
  QString   _description;
  QString   _owner;
  QString   _status; 

private:

  struct LabelCache : IUpdateable< LabelList > {
    void HandleError( Error* err );
    void OutputStat( StrDict* varList );
    void updateCache();
  };

  friend LabelCache;

  static LabelCache _labelCache;

};


inline const QString& Label:: getName() const
{
  return _name;
}

inline const QString& Label::getDescription() const
{
  return _description;
}

inline const QString&   Label::getOwner() const
{
  return _owner;
}


inline const QDateTime& Label::getDate() const
{
  return _date;
}

inline const QString& Label::getStatus() const
{
  return _status;
}




} // end namespace


#endif
